mtl-2.1.2: Monad classes, using functional dependencies

Portability | portable
Stability | experimental
Maintainer | libraries@haskell.org
Safe Haskell | Safe-Inferred

Control.Monad.List

Description

The List monad.

Synopsis

- newtype ListT m a = ListT {
  - runListT :: m [a]
  }
- mapListT :: (m [a] -> n [b]) -> ListT m a -> ListT n b
- module Control.Monad
- module Control.Monad.Trans

# Documentation

newtype ListT m a

Parameterizable list monad, with an inner monad.

Note: this does not yield a monad unless the argument monad is commutative.

Constructors

ListT |
Fields runListT :: m [a]

Instances

MonadTrans ListT |
MonadState s m => MonadState s (ListT m) |
MonadReader r m => MonadReader r (ListT m) |
MonadError e m => MonadError e (ListT m) |
Monad m => Monad (ListT m) |
Functor m => Functor (ListT m) |
Monad m => MonadPlus (ListT m) |
Applicative m => Applicative (ListT m) |
Foldable f => Foldable (ListT f) |
Traversable f => Traversable (ListT f) |
Applicative m => Alternative (ListT m) |
MonadIO m => MonadIO (ListT m) |
MonadCont m => MonadCont (ListT m) |

mapListT :: (m [a] -> n [b]) -> ListT m a -> ListT n b

Map between `ListT` computations.

-     runListT (mapListT f m) = f (runListT m)

module Control.Monad

module Control.Monad.Trans